/* This notice must remain at all times.

graph.js
Copyright (c) Balamurugan S, 2005. sbalamurugan @ hotmail.com
Development support by Jexp, Inc http://www.jexp.com 

This package is free software. It is distributed under GPL - legalese removed, it means that you can use this for any purpose, but cannot charge for this software. Any enhancements you make to this piece of code, should be made available free to the general public! 

Latest version can be downloaded from http://www.sbmkpm.com

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

graph.js provides a simple mechanism to draw bar graphs. It  uses 
wz_jsgraphics.js  which is copyright of its author. 

Usage:
var g = new graph();
g.add("title1",value);
g.add("title2",value2);

g.render("canvas_name", "graph title");

//where canvas_name is a div defined INSIDE body tag 
<body>
<div id="canvas_name" style="overflow: auto; position:relative;height:300px;width:400px;"></div>


*/

hD="0123456789ABCDEF";

function d2h(d) 
{
 var h = hD.substr(d&15,1);
 while(d>15) {d>>=4;h=hD.substr(d&15,1)+h;}
 return h;
}

function h2d(h) 
{
 return parseInt(h,16);
}

function graph()
{
 this.ct = 0;
 
 this.data      = new Array();
 this.x_name    = new Array();
 this.scale     = 1;
 this.max       = -64000; //MAX INT
 this.min       = 64000;

 this.c_array = new Array();
 this.c_array[0] = new Array(255, 192, 95);
 this.c_array[1] = new Array(80, 127, 175);
 this.c_array[2] = new Array(159, 87, 112);
 this.c_array[3] = new Array(111, 120, 96);
 this.c_array[4] = new Array(224, 119, 96);
 this.c_array[5] = new Array(80, 159, 144);
 this.c_array[6] = new Array(207, 88, 95);
 this.c_array[7] = new Array(64, 135, 96);
 this.c_array[8] = new Array(239, 160, 95);
 this.c_array[9] = new Array(144, 151, 80);
 this.c_array[10] = new Array(255, 136, 80);

 this.getColor = function()
  {
   if(this.ct >= (this.c_array.length-1))
      this.ct = 0;
   else
      this.ct++;

   return "#" + d2h(this.c_array[this.ct][0]) + d2h(this.c_array[this.ct][1]) + d2h(this.c_array[this.ct][2]);
  }


 this.setScale = function(scale)
  {
   this.scale  = scale;
  }

 this.add = function(x_name, value)
  {
   value = parseFloat(value,10)*this.scale;

   this.x_name.push(x_name);  
   this.data.push(parseFloat(value,10));

   if(value > this.max)
      this.max = parseFloat(value,10);
   if ((value < this.min) && (value != -99999))
      this.min = parseFloat(value,10);
  }

 this.clear = function()
 {
    this.max       = -64000; //MAX INT
    this.min       = 64000;    
    while (this.data.length > 0)
      this.data.pop();
    while (this.x_name.length > 0)
      this.x_name.pop();
 }
 
 this.render = function(canvas, wind, width, height, decimalPoints)
  {
   var jg = new jsGraphics(canvas, wind);

   jg.setColor("white");
   jg.fillRect(1, 1, width, height);

   var shadow = 3;
   var fnt    = 12;
   var canvasGapLeft = (decimalPoints == 2) ? 30 : 40;
   var canvasGapRight = 2;
   var canvasX = canvasGapLeft;
   var canvasWidth = width - (canvasGapLeft+canvasGapRight);
   var canvasGapTop = 8;
   var canvasGapBottom = 2;
   var canvasY = canvasGapTop;
   var canvasHeight = height - (canvasGapTop + canvasGapBottom);

//   jg.setColor("red");
  // jg.fillRect(canvasX, canvasY, canvasWidth, canvasHeight);

    var verticalLines = 6;
    var lineStartY = 10;
    var lineGap = (canvasHeight / verticalLines);
    

   var maxRange = parseFloat(this.max - this.min);
    var tmax = parseFloat(this.max) + parseFloat(maxRange) * parseFloat(0.1);
    var tmin = (this.min == 0) ? 0 : parseFloat(this.min) - Math.abs(parseFloat(maxRange) * parseFloat(0.1));
    if (tmax == 0)
        tmax = 1;
    if (tmin < 0)
        tmin = 0;
    var maxRange = parseFloat(tmax - tmin);

    var itemGap = parseFloat(maxRange / (verticalLines-1)).toFixed(5);
    var displayScale = tmin+itemGap * (verticalLines-1);
    var heightYMin = lineStartY+1;
    for (i = 0; i < verticalLines; i++)
    {
        jg.setColor("silver");
        jg.drawLine(canvasX,lineStartY,canvasX+canvasWidth-1,lineStartY);
        jg.setColor("black");
        jg.setFont("Calibri", "7pt", "normal")
        if (parseFloat(displayScale.toFixed(decimalPoints)) == 0)
            displayScale = 0;
        jg.drawStringRect(displayScale.toFixed(decimalPoints),1, lineStartY-(lineGap / 2)+1, canvasGapLeft-3, "center");

       displayScale -= itemGap;
       lineStartY += lineGap;      
    }

    var heightMax = (lineGap * (verticalLines-1));
    var heightYMax = heightYMin + heightMax;
  
    var columnWidth = canvasWidth / this.data.length;
   // Draw the bar graph
   var x = canvasX;
   for(i = 0; i < this.data.length; i++)
      {
       if (this.data[i] == -99999)
          continue;
       var columnHeight = Math.round(this.data[i]*heightMax/tmax);

       // shadow
       jg.setColor("gray");
       if(columnHeight-shadow > 1)
          jg.fillRect(x+shadow,heightYMin+shadow+(heightMax - columnHeight),columnWidth-10,columnHeight-(shadow+1));


       jg.setColor("black");
       if (columnHeight > 0)
       {
        var columnStartY = heightYMin+(heightMax - columnHeight);
        jg.fillRect(x, columnStartY,columnWidth-10,columnHeight);

        jg.setColor("maroon");
        jg.fillRect(x+1,columnStartY+1,columnWidth-12,(columnHeight-2 <= 0) ? 1 : columnHeight-2);
       }

        jg.setColor("black");
       jg.drawStringRect(this.x_name[i], x, heightYMax, columnWidth-10, "center");

        x = x + columnWidth;
      }
   jg.paint();
  }

}
