var gadgetVersion="1.8.0.0";
var resetInterval = null;

var dialOffset = 0;

var intWindDialPos = dialOffset;

var lastWindDirection = dialOffset;
var currentWindDirection = dialOffset;

var intRotateStep = 5;
var intNoAnimThresh = 4;

var cpuBackground;
var memoryBackground;
var displayTimeout;
var dialTimeout;
var refreshTimeout;
var panelTimeout;
var isError = 0;
var panelIndex = 0;
var panelMaxIndex = 3;
var FlyOut ="";

var clientRawArray;
var clientRawExtraArray;
var thePressureFormat=0;
var theWinspeedUnit=0;

var error404OrTimeout = 0;

var tempTrend;
var pressureTrend;
var rainGraph;

var defaultPressureFormat = 0; // hPa
var defaultTemperatureUnit = 0; // Celsius
var defaultDisplayInterval = 15; // Seconds
var defaultRefreshInterval = 300; // Seconds
var defaultRainfallUnit = 0; // millimeters
var defaultWindspeedUnit = 0; // kph
var newGadgetVersionAvailable = 0;

var data = new WeatherData();

var gadgetUpdateURL = "http://weather.cobbnz.com/vistagadgetlatestversion.xml"
var WeatherClientRaw;
var WeatherClientRawExtra;
var WeatherClientRawURL;
var WeatherClientRawExtraURL;

function setup()
{
    hideSpinner();
    System.Gadget.Flyout.onHide = flyoutHiding;
    System.Gadget.Flyout.onShow = flyoutShowing;
	System.Gadget.Flyout.file = "flyout.html";

    if (System.Gadget.Settings.read("WeatherURL") == "")
    {
        System.Gadget.Settings.write("CheckNextForUpdate", new Date().getTime()+ ( 1000 * 60));
        System.Gadget.Settings.write("WeatherURL", 'http://weather.cobbnz.com');
        System.Gadget.Settings.write("WeatherLocation", 'Fendalton, Christchurch, South Island, New Zealand');
        System.Gadget.Settings.write("WeatherName", 'Fendalton Weather Service');
        System.Gadget.Settings.write("WeatherClientRaw", 'clientraw.txt');
        System.Gadget.Settings.write("WeatherclientRawExtra", 'clientrawextra.txt');
        System.Gadget.Settings.write("DisplayInterval", defaultDisplayInterval);
        System.Gadget.Settings.write("RefreshInterval", defaultRefreshInterval);
        System.Gadget.Settings.write("TemperatureUnit", defaultTemperatureUnit);        
        System.Gadget.Settings.write("PressureFormat", defaultPressureFormat);        
        System.Gadget.Settings.write("RainfallUnit", defaultRainfallUnit);        
        System.Gadget.Settings.write("WindspeedUnit", defaultWindspeedUnit);     
        System.Gadget.Settings.write("OptionsSolar", 1);
        System.Gadget.Settings.write("OptionsUV", 1);
        System.Gadget.Settings.write("Optionsimages", 1);
        System.Gadget.Settings.write("OptionsCycleHumidity", 1);
        System.Gadget.Settings.write("OptionsCyclePressure", 1);
        System.Gadget.Settings.write("OptionsCycleRain", 1);   
    }

    System.Gadget.settingsUI="settings.html";
    System.Gadget.onSettingsClosed  = settingsClosed;
    refreshSettings();
    
	vaneMeter.src = "images/needle.png";
    vaneMeter.addShadow("grey", 2, 40, 2, 2);
	with (vaneMeter.style)
    {
        left = "93px";
        top = "16px";
    }
    
    this.tempTrend = new line_graph();
    this.pressureTrend = new line_graph();
    this.rainGraph = new graph();
  
    showPanel(0, false);
	GetClientRaw();	
    displayTimeout = setTimeout('nextPanel()', System.Gadget.Settings.read("DisplayInterval") * 1000);
    
}


function settingsClosed()
{
    panelIndex = 0;
   
    refreshSettings();
    clearTimeout(displayTimeout);
    displayTimeout = setTimeout('nextPanel()', System.Gadget.Settings.read("DisplayInterval") * 1000);
    GetClientRaw();
    if (isError == 0)
        showPanel(0, false);
}

function getVersionAsFloat(ver)
{
    var bits = ver.split('.');
    if (bits.length != 4)
      return 0;
    else
      return (parseFloat(bits[0]) * 0xffffff)+
             (parseFloat(bits[1]) * 0xffff)+
             (parseFloat(bits[2]) * 0xff)+
             parseFloat(bits[3]);            
}

function refreshSettings()
{
    data.temperatureUnit = System.Gadget.Settings.read("TemperatureUnit");
    document.getElementById('tempunit').innerHTML = (data.temperatureUnit == 0) ? "Celsius" : "Fahrenheit";

    data.pressureUnit = System.Gadget.Settings.read("PressureFormat");
    document.getElementById('pressureFormat').innerHTML = (data.pressureUnit == 0) ? "hPa" : (data.pressureUnit == 1) ? "inHg" : "millibar";

    data.rainfallUnit = System.Gadget.Settings.read("RainfallUnit");
    document.getElementById('rainUnit').innerHTML = (data.rainfallUnit == 0) ? "mm rain" : "in rain";

    data.windspeedUnit = System.Gadget.Settings.read("WindspeedUnit");

    WeatherClientRaw = System.Gadget.Settings.read("WeatherClientRaw");
    WeatherClientRawExtra = System.Gadget.Settings.read("WeatherClientRawExtra");

    data.showHumidity = System.Gadget.Settings.read("OptionsCycleHumidity");
    data.showPressure = System.Gadget.Settings.read("OptionsCyclePressure");
    data.showRain     = System.Gadget.Settings.read("OptionsCycleRain");
   
}

function toggleFlyoutWindow()
{
    if (System.Gadget.Flyout.show == true)
        System.Gadget.Flyout.show = false;
    else 
        System.Gadget.Flyout.show = true;
}

function flyoutHiding()
{    
    nextPanel();
	GetClientRaw();
}

function flyoutShowing()
{
    getClientRawExtra();
}

function animateWindVane()
{
    clearTimeout(dialTimeout);
    
    var cpuUpdated = false;
    var cpuDiff = 0;
  
    if (Math.round(lastWindDirection) != Math.round(currentWindDirection))
    {
        cpuDiff = Math.abs(lastWindDirection - currentWindDirection);
        lastWindDirection = currentWindDirection;
       
        cpuUpdated = true;
    }    
   
    if (cpuUpdated)
    {
        // something changed...
       if (cpuDiff < intNoAnimThresh)
        {
            // too small - don't animate
            moveDial((currentWindDirection - intWindDialPos), intRotateStep);
        }
        else
        {
            // animate as usual
          moveDial(((currentWindDirection - intWindDialPos) / intRotateStep),  0);
       }
    }
}

function moveDial(cpuInc, dialStep)
{
	intWindDialPos += cpuInc;
	
	if (cpuInc > 0)
		intWindDialPos = Math.min(Math.max(0, intWindDialPos), lastWindDirection);
	else
		intWindDialPos = Math.max(Math.max(0, lastWindDirection), intWindDialPos);
	
	if (dialStep < intRotateStep - 1)
		vaneMeter.Rotation = intWindDialPos; 

    if (dialStep < intRotateStep)
       dialTimeout = setTimeout("moveDial(" + cpuInc+ "," + (++dialStep) + ")", 100);
    else
        vaneMeter.Rotation = lastWindDirection;
}

function nextPanel()
{
    var startPanelIndex = panelIndex;
    
    clearTimeout(displayTimeout);
	if (isError == 0)
	{
	    panelIndex++;
	    // Panels : 0 = Temp, 1=Humidity, 2=Pressure, 3=Rain, 4=New Update
	    if ((panelIndex == 1) && (data.showHumidity == 0))
	      panelIndex++;
	    if ((panelIndex == 2) && (data.showPressure == 0))
	      panelIndex++;
	    if ((panelIndex == 3) && (data.showRain == 0))
	      panelIndex++;
    
		if (panelIndex > panelMaxIndex) 
			panelIndex = 0; // Temperature
		
		if (startPanelIndex != panelIndex)
		    showPanel(panelIndex, true);
	}        
	displayTimeout = setTimeout('nextPanel()', System.Gadget.Settings.read("DisplayInterval") * 1000);
}

function checkForNewGadget()
{
    var NextUpdate = parseFloat(System.Gadget.Settings.read("CheckNextForUpdate"));
    if (NextUpdate < new Date().getTime())
    {
        System.Gadget.Settings.write("CheckNextForUpdate", new Date().getTime()+ ( 1000 * 60 * 60));
                   
        var h = new Http();
        if (h.Get(gadgetUpdateURL+"?Random="+Math.random()) == true)
        {
            var lastestRelease = h.responseXML.selectSingleNode("/Gadget").attributes[0].text;
            if (getVersionAsFloat(lastestRelease) > getVersionAsFloat(gadgetVersion))
            {
                // 
                panelMaxIndex = 4;
                document.getElementById("updateAvailable").href="http://weather.cobbnz.com/vistagadget.aspx?currentVersion="+gadgetVersion;
            }	            
        }
        else
           showError("Unable to read data : " + h.url+"<br><br>"+h.errorMessage, "Update Check Failed");
    }
}

function getURL(key)
{
   var Url  = System.Gadget.Settings.read("WeatherURL");
   
   if (Url.substring(Url.length-1,Url.length) != "/")
        Url += "/";
    return Url+System.Gadget.Settings.read(key)+"?x="+Math.random();
}

function GetClientRaw() 
{
    var theRefreshInterval  = System.Gadget.Settings.read("RefreshInterval");
    var tmpIsError = isError;
    try
    {
        if (tmpIsError == 0)
            showSpinner();
        clearTimeout(refreshTimeout);

        checkForNewGadget();
        var h = new Http();
        if (h.Get(getURL("WeatherClientRaw")) == true)
        {
            // We have seen issues where we get a 200 response, but we get no data returned. We speculate that this
            // is related to an update of the data, and the Web Server is returning "" as the file is empty during the
            // upload.
            if (h.responseText.length == 0)
            {
                error404OrTimeout++;
                if (error404OrTimeout == 10)
                {
                    showError("Unable to read clientraw data : " + h.url+"<br><br>"+h.errorMessage, "No Data Returned");
                    error404OrTimeout = 0;
                }
                else
                    // retry in 1 second
                    theRefreshInterval = 3; // retry in 1 second
            }
            else 
            {
                error404OrTimeout=0;

                if (data.setClientRaw(h.responseText) == true)
                    updateGadget();
                else
                    showError("The clientraw.txt file does not contain the clientraw.txt header - therefore it cannot be parsed.<br><br>The URL was : " + h.url, "Missing Header");
            }
        }
        else
        {
            if (h.isErrorA404OrTimeout())
            {
                error404OrTimeout++;
                if (error404OrTimeout == 3)
                {
                    showError("Unable to read clientraw data : " + h.url+"<br><br>"+h.errorMessage, "Timeout or data not found");
                    error404OrTimeout = 0;
                }
                else
                    theRefreshInterval = 3; // retry in 2 seconds.
            }
            else
            {
                showError("Unable to read clientraw data : " + h.url+"<br><br>"+h.errorMessage, "Read Error");
            }
        }
    }
    finally
    {
        if (tmpIsError == 0)        
            setTimeout(hideSpinner, 1500);
        
        refreshTimeout = setTimeout('GetClientRaw()', theRefreshInterval * 1000);  
    }
}

function getClientRawExtra() 
{
    var tmpIsError = isError;
    try
    {
        if (tmpIsError == 0)
            showSpinner();

        var h = new Http();
        if (h.Get(getURL("WeatherClientRawExtra")) == true)
        {
            if (h.responseText.length == 0)
            {
                error404OrTimeout++;
                if (error404OrTimeout == 3)
                {
                    showError("Unable to read clientrawextra data : " + h.url+"<br><br>"+h.errorMessage, "No Data Returned");
                    error404OrTimeout = 0;
                }
                else
                    // retry in 1 second
                    theRefreshInterval = 2; // retry in 1 second
            }
            else 
            {
                error404OrTimeout=0;
                if (data.setClientRawExtra(h.responseText) == true)
                {
                    updateGadgetFlyout();
                }
               else
                   showError("The clientrawextra.txt file does not contain the clientrawextra.txt header - therefore it cannot be parsed.<br><br>The URL was : " + h.url, "Missing Header");
            }
        }
        else
        {
            if (h.isErrorA404OrTimeout())
            {
                error404OrTimeout++;
                if (error404OrTimeout == 3)
                {
                    showError("Unable to read clientrawextra data : " + h.url+"<br><br>"+h.errorMessage, "Timeout or data not found");               
                    error404OrTimeout = 0;
                }
            }
            else
               showError("Unable to read clientrawextra data : " + h.url+"<br><br>"+h.errorMessage, "Read Error");               
        }
        }
    finally
    {
        updateGadgetFlyoutVersions();
        if (tmpIsError == 0)
            setTimeout(hideSpinner, 1500);
    }
}

function hideSpinner()
{
    eval("spinner").style.visibility = "hidden";
    eval("vaneBlack").style.visibility = "hidden";
}

function showSpinner()
{
    eval("vaneBlack").src="images/vaneblack.png";
    eval("vaneBlack").style.visibility = "visible";
    eval("spinner").src="images/16-on-black.gif";
    eval("spinner").style.visibility = "visible";
}

function showError(message, shortMessage)
{
    // Only log the error on the first failure, if we get a success then isError will be 0
    if (isError == 0)
        System.Diagnostics.EventLog.writeEntry(message, 2); // 0=Success, 1=Error, 2=Warning, 3=Information
    hideSpinner();
    isError = 1;
    setBackground("images/error.png");
    document.getElementById("panelError").innerHTML = shortMessage;
    document.getElementById("panelError").style.visibility = "visible";    
    showPanel(99, false);
}

function setBackground(value)
{
   document.getElementById("background").src = value;
}

function updateGadget()
{
    // If an error is showing, and the flyout is out, close it since the error has gone away.
    if (isError == 1)
      if (System.Gadget.Flyout.show == true)
        System.Gadget.Flyout.show = false;
        
    
    if (data.getAgeOfClientRawInHours() > 36)
    {
       showError("The data in the clientraw.txt file is more than 36 hours old and therefore will not be displayed.<br><br>The file data is dated : " + data.formatDateTime() +" which is " + data.getAgeOfClientRawInHours()+" hours old!<br><br>The URL was : " + System.Gadget.Settings.read("WeatherURL"), "Data > 36 hours old");
    }    
    else
    {
        isError = 0;  	        
        
	    var temperatureCurrent = data.temperatureCurrent();    
        SetGadgetValue('temp',      data.formatTemperature(temperatureCurrent));
        SetGadgetValue('rain',      data.formatRain(data.rainToday()));
        SetGadgetValue('humidity',  data.formatHumidity(data.humidityCurrent()));
        SetGadgetValue('pressure',  data.formatPressure(data.pressureCurrent()));
        SetGadgetValue('windSpeed', data.formatWindSpeed(data.windspeedCurrent()));


        SetGadgetValue('station',   data.stationName());
        

        // Save the new Wind direction for when we are animating the wind vane
        currentWindDirection = data.windDirectionCurrent();

        // Set the background image.....
	    setBackground(data.getBackground());

        showPanel(panelIndex, false);	    
/*

        There appears to be a memory leak in the code that draws the graph and I 
        can't find it so we will not update the flyout once it is opened.
	    if (System.Gadget.Flyout.show == true)
	      getClientRawExtra();
*/
    }
    animateWindVane();
}

function updateGadgetFlyoutVersions()
{
    SetFlyoutValue('lblWeatherDisplayVersion', data.formatVersions(gadgetVersion));
    SetFlyoutValue('flyoutTitleLink', System.Gadget.Settings.read("WeatherName"));
    SetFlyoutValue('flyoutTitleLocation',System.Gadget.Settings.read("WeatherLocation"));
    SetFlyoutValue('lblDateTime', data.formatDateTime());
    System.Gadget.Flyout.document.getElementById('lblDateTime').href = System.Gadget.Settings.read("WeatherURL");
}

function updateGadgetFlyout()
{
    isError = 0;  	    

    updateGadgetFlyoutVersions();
    
    // Process the data for the temperature trend chart
    this.tempTrend.clear();
    this.pressureTrend.clear();
    this.rainGraph.clear();
    
    var items = data.getTempTrendData();
    for (i = 0; i< items.length; i++)
        this.tempTrend.add(items[i][0], items[i][1]);
    this.tempTrend.render("TempTrend", System.Gadget.Flyout, 1, 340, 125);

    SetFlyoutValue('Temp',data.formatTemperature(data.temperatureCurrent()));
    
    SetFlyoutValue('lblTempTodayMin', data.formatTemperature(data.clientRawArray[47]));
    SetFlyoutValue('lblTempTodayMax', data.formatTemperature(data.clientRawArray[46]));

    SetFlyoutValue('lblTempThisYearMin', data.formatTemperature(data.clientRawExtraArray[193]));
    SetFlyoutValue('lblTempThisYearMax', data.formatTemperature(data.clientRawExtraArray[187]));

    SetFlyoutValue('lblTempAllTimeMin', data.formatTemperature(data.clientRawExtraArray[319]));
    SetFlyoutValue('lblTempAlltimeMax', data.formatTemperature(data.clientRawExtraArray[313]));    
  
    // Process the data for the pressure trend chart
    var items = data.getPressureTrendData();
    for (i = 0; i< items.length; i++)
        this.pressureTrend.add(items[i][0], items[i][1]);
    this.pressureTrend.render("PressureTrend", System.Gadget.Flyout, 2, 340, 125);
    
    SetFlyoutValue('lblPressureTodayMax', data.formatPressure(data.clientRawArray[131]));
    SetFlyoutValue('lblPressureTodayMin',data.formatPressure(data.clientRawArray[132]));

    SetFlyoutValue('lblPressureThisYearMax',data.formatPressure(data.clientRawExtraArray[217]));
    SetFlyoutValue('lblPressureThisYearMin',data.formatPressure(data.clientRawExtraArray[211]));

    SetFlyoutValue('lblPressureAllTimeMax',data.formatPressure(data.clientRawExtraArray[343]));
    SetFlyoutValue('lblPressureAllTimeMin',data.formatPressure(data.clientRawExtraArray[337]));

    // Process the data for the rain graph
    var items = data.getRainTrendData();
    for (i = 0; i< items.length; i++)
        this.rainGraph.add(items[i][0], items[i][1]);
    this.rainGraph.render("RainfallTrend", System.Gadget.Flyout, 340, 125, (data.formatRainSymbol() == "mm" ? 2 : 3));
    
    SetFlyoutValue('RainToday', data.formatRain(data.clientRawArray[7]));
    SetFlyoutValue('RainYesterday', data.formatRain(data.getRainYesterday()));
    SetFlyoutValue('RainThisMonth', data.formatRain(data.clientRawArray[8]));
    SetFlyoutValue('RainThisYear', data.formatRain(data.clientRawArray[9]));  

    SetFlyoutValue('lblSun', (System.Gadget.Settings.read("OptionsSolar") == 0) ? "n/a" : data.formatSun(data.clientRawExtraArray[696]));  
    SetFlyoutValue('lblUV', (System.Gadget.Settings.read("OptionsUV") == 0) ? "n/a" : data.formatUV(data.clientRawArray[79]));  
    
    SetFlyoutValue('Forecast', data.getForecast());
    
    SetFlyoutValue('DewPoint',data.formatTemperature(data.clientRawArray[72]));
    SetFlyoutValue('Pressure',data.formatPressure(data.clientRawArray[6]));
    SetFlyoutValue('Humidity',data.formatHumidity(data.humidityCurrent()));
    
    

    var tempTrend = parseFloat(data.clientRawArray[143]);
    var baroTrend = parseFloat(data.clientRawArray[50]);
    var humidityTrend = parseFloat(data.clientRawArray[144]);

    SetFlyoutValue('lblTemp', 'Temperature ('+ ( data.temperatureUnit == 1 ? "Fahrenheit" : "Celsius")+")");
    SetFlyoutValue('lblTempTrend', 'Temperature (24 Hours / '+ ( data.temperatureUnit == 1 ? "Fahrenheit" : "Celsius")+")");
    
    SetFlyoutValue('lblPressure', 'Barometric Pressure ('+ ( data.pressureUnit == 0 ? "hPa" : data.pressureUnit == 1 ? "Inches" : "Millibars")+")");
    SetFlyoutValue('lblPressureTrend', 'Barometric Pressure (24 Hours / '+ ( data.pressureUnit == 0 ? "hPa" : data.pressureUnit == 1 ? "Inches" : "Millibars")+")");
   
    SetFlyoutValue('lblRain', 'Rainfall ('+ ( data.rainfallUnit == 0 ? "Millimeters" : "Inches")+")");
    SetFlyoutValue('lblRainfallTrend', 'Rainfall (7 Days / '+ ( data.rainfallUnit == 0 ? "Millimeters" : "Inches")+")");
   
    System.Gadget.Flyout.document.getElementById('TempTrendImg').src = (tempTrend < 0) ? "images/falling.gif" : (tempTrend > 0) ? "images/rising.gif" : "images/1x1.gif";
    System.Gadget.Flyout.document.getElementById('PressureTrendImg').src = (baroTrend < 0) ? "images/falling.gif" : (baroTrend > 0) ? "images/rising.gif" : "images/1x1.gif";
    System.Gadget.Flyout.document.getElementById('HumidityTrendImg').src = (humidityTrend < 0) ? "images/falling.gif" : (humidityTrend > 0) ? "images/rising.gif" : "images/1x1.gif";

    SetFlyoutValue('lblDateTime', data.formatDateTime());
    System.Gadget.Flyout.document.getElementById('lblDateTime').href = System.Gadget.Settings.read("WeatherURL");
    System.Gadget.Flyout.document.getElementById('lblError').style.visibility = "hidden";
}

function SetGadgetValue(elem, data)
{
    document.getElementById(elem).innerHTML = data;
}

function SetFlyoutValue(elem, data)
{
    System.Gadget.Flyout.document.getElementById(elem).innerHTML = data;
}

function showPanel(panelID,animate)
{
    var src = data.getTrendImage(panelID);
    if (src.length > 0)
    {
        document.getElementById("trendimg").src = "images/"+src+".gif";
        document.getElementById("trendimg").style.visibility = "visible";
    }
    else
        document.getElementById("trendimg").style.visibility = "hidden";
        

    document.getElementById("panel0").style.visibility = "hidden";
    document.getElementById("panel1").style.visibility = "hidden";
    document.getElementById("panel2").style.visibility = "hidden";
    document.getElementById("panel3").style.visibility = "hidden";
    document.getElementById("panel4").style.visibility = "hidden";
    
    document.getElementById("windSpeed").style.visibility = (panelID != 99) ? "visible" : "hidden";
    document.getElementById("station").style.visibility = (panelID != 99) ? "visible" : "hidden";
    document.getElementById("vaneMeter").style.visibility =(panelID != 99) ? "visible" : "hidden";
    document.getElementById("vane").style.visibility = (panelID != 99) ? "visible" : "hidden";
    document.getElementById("updateAvailable").style.visibility = (panelID == 4) ? "visible" : "hidden";
    document.getElementById("panelError").style.visibility = (panelID == 99)  ? "visible" : "hidden";

    
    if (panelID != 99)
    {
        if (animate == true)
            document.getElementById("oTransContainer").filters[0].Apply();
        document.getElementById("panel"+panelID).style.visibility = "visible";
        if (animate == true)
            document.getElementById("oTransContainer").filters[0].Play();
    }
}
